#define LARG 600
#define HAUT 220
#include <wingraph.h>
//#include "bd_couleurs.h"
#define NB_MAX 200
unsigned char (*melanges)[3] = NULL;
unsigned char (*noms)[20] = NULL;
int nbChaines=0;

int interdit=0;

/*------------------------------------------atox--------------------------------------*\
| Arguments:                                                                           |
|    -chn (chane): Chane contenant un nombre hexa  convertir                        |
| Retour:                                                                              |
|     (entier): Valeur entire correspondante  la chane hexa                         |
|--------------------------------------------------------------------------------------|
| Convertit une chane en nombre hexadcimal et renvoie l'entier correspondant.        |
\*--------------------------------------------------------  2003 Florian Brnnimann--*/

int atox(char *chn)	{
	int i;
	int n;
	int v;
	char *deb;
	deb=chn;
	while(*(++chn));
	chn--;
	i=1;
	n=0;
	while(chn>=deb)	{
		v=*(chn)-48;
		if (v>=17+32)	v-=39;
		if (v>=17)		v-=7;
		n+=i*v;
		i*=16;
		chn--;
	}
	return n;
}

int ModValeur(int r)		{
	int x,y;
	static int derY=0;
	char chaine[100];
	PositionSouris(&x,&y);
	if ((x/LARG_CAR<=20 || x>475) && derY!=y/HAUT_CAR && interdit!=0)
		toucheAppuyee(T_SOURIS_GAUCHE);
	if (interdit!=0 && derY!=y/HAUT_CAR)		{
		return r;
	}
	derY=y/HAUT_CAR;
	if (interdit>1)
		interdit--;
	if (interdit<=1)		{
		if (interdit==0)	interdit=50;
		else				interdit=4;
		if (x/LARG_CAR==14)
			r-=10;
		if (x/LARG_CAR==16)
			r--;
		if (x/LARG_CAR==18)
			r++;
		if (x/LARG_CAR==20)
			r+=10;
		if (x/LARG_CAR>=7 && x/LARG_CAR<=9)		{
			MoveTo(7,(y/HAUT_CAR));
			printf("   ");
			MoveTo(7,(y/HAUT_CAR));
			ModeConsole();
			memset(chaine,0,sizeof(chaine));
			LongueurMax(4);
			gets(chaine);
			if (chaine[0])
				r=atoi(chaine);
			ModeGraphique();
		}
	}
	if (x>=200 && x<250)
		r=0;
	if (x>=250 && x<=505)
		r=x-250;
	if (x>505 && x<555)
		r=255;
	if (r<0)		r=0;
	if (r>255)		r=255;
	return r;
}

void AffCouleurs(int depuis)		{
	int i;
	EffaceEcran();
	for (i=depuis;i<depuis+HAUT/HAUT_CAR-2;i++)
		DessTexte(8,HAUT_CAR*(i-depuis+1)-3,noms[i]);
	if (i>=nbChaines)
		CouleurTexte(GRIS);
	DessTexte(200,HAUT_CAR*(i-depuis+1)-3,"Bas (avec souris)");
	CouleurTexte(TEXTE_NORMAL);
	if (depuis<=0)
		CouleurTexte(GRIS);
	DessTexte(200,-3,"Haut (avec souris)");
	CouleurTexte(TEXTE_NORMAL);
}

int ChoisitCouleur(int *r, int *v, int *b)		{
	int i,j, x,y;
	static int index=0;					//Reste enregistr pour une prochaine visite...
	toucheAppuyee(T_SOURIS_GAUCHE);
	VideRouletteSouris();
	while(!toucheAppuyee(T_ESCAPE) && !toucheAppuyee(T_SOURIS_DROIT))		{
		EffaceEcran();
		AffCouleurs(index);
		PositionSouris(&x,&y);
		i=y/HAUT_CAR;
		j=RouletteSouris();
		if ((j<0 || toucheAppuyee(T_HAUT)) && index>0)
			index--;
		if ((j>0 || toucheAppuyee(T_BAS)) && index+HAUT/HAUT_CAR-2<nbChaines)
			index++;
		if (i>=0 && i<HAUT/HAUT_CAR && x<=400 && i<=nbChaines)			{
			if (!(i==0 && index==0) && !(i==HAUT/HAUT_CAR-1 && index+HAUT/HAUT_CAR-2>=nbChaines))
				AdditionneCadre(0,i*HAUT_CAR,400,HAUT_CAR-1,RGB(0,0,128));
			if (i!=0 && i!=HAUT/HAUT_CAR-1)		{
				j=i+index-1;
				ColoreCadre(425,20,160,HAUT-40,RGB(melanges[j][0],melanges[j][1],melanges[j][2]));
			}
			if (toucheAppuyee(T_SOURIS_GAUCHE))		{
				if (i>0 && i<HAUT/HAUT_CAR-1)		{
					j=i+index-1;
					*r=melanges[j][0];
					*v=melanges[j][1];
					*b=melanges[j][2];
					return 1;
				}
				if (i==HAUT/HAUT_CAR-1 && index+HAUT/HAUT_CAR-2<nbChaines)
					index++;
				if (i==0 && index>0)
					index--;
			}
		}
		AfficheEcran();
		AttendSync(10);
	}
	return 0;
}

void CapturePoint(int *r, int *v, int *b)		{
	POINT point;
	int c, mode_actif=0, rr,vv,bb, clicinterdit=1, i;
	TitreFenetre("Cliquez  l'endroit o vous voulez saisir la couleur... Clic droit = annuler");
	AttenteASynchrone();
	for (i=111;i<=187;i+=2)	{
		if (!skip)		{
			GetCursorPos(&point);
			c=GetPixel(GetDC(NULL),point.x,point.y);
			bb=(c&0x00ff0000)>>16;
			vv=(c&0x0000ff00)>>8;
			rr=(c&0x000000ff);
			ColoreCadre(10,111,580,i-111,RGB(rr,vv,bb));
			AfficheEcran();
		}
		ColoreCadre(10,i+2,580,2,BLANC);
		AttendSync(5);
	}
	AttenteMinimale();

	while(!GetAsyncKeyState(T_SOURIS_GAUCHE) || clicinterdit)		{
		if (!GetAsyncKeyState(T_SOURIS_GAUCHE) && !GetAsyncKeyState(T_SOURIS_DROIT) && !GetAsyncKeyState(T_SOURIS_MILIEU))
			clicinterdit=0;

		if ((GetAsyncKeyState(T_SOURIS_DROIT) || GetAsyncKeyState(T_SOURIS_MILIEU)) && !clicinterdit)	{
			toucheAppuyee(T_SOURIS_GAUCHE);
			toucheAppuyee(T_SOURIS_DROIT);
			toucheAppuyee(T_SOURIS_MILIEU);
			return;
		}

		GetCursorPos(&point);
		c=GetPixel(GetDC(NULL),point.x,point.y);
		bb=(c&0x00ff0000)>>16;
		vv=(c&0x0000ff00)>>8;
		rr=(c&0x000000ff);
		ColoreCadre(10,111,580,78,RGB(rr,vv,bb));
		AfficheEcran();
		AttendSync(10);
	}
	*b=bb;
	*v=vv;
	*r=rr;
	toucheAppuyee(T_SOURIS_GAUCHE);
	toucheAppuyee(T_SOURIS_DROIT);
	toucheAppuyee(T_SOURIS_MILIEU);
}

void main(void)		{
	int r,v,b, rd,vd,bd, x,y, i,j, diff, degrade=0;
	FILE *f;
	char str[100], str2[100];
	melanges=calloc(NB_MAX,3);
	noms=calloc(NB_MAX,20);
	r=0;
	v=0;
	b=128;
	ModeGraphique();
	InitTimer();
	AttenteMinimale();
	TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
debut:
	f=fopen("couleurs.txt","r");
	if (f)		{
		i=0;
		while(i<NB_MAX)		{
			fgets(str,40,f);
			if (feof(f))
				break;
			for (j=0;str[j]!='=' && str[j];j++);
			if (!str[j])
				break;
			str[strlen(str)-1]=0;
			str[j]=0;
			strcpy(noms[i],str);
			j+=2;
			x=atox(str+j);
			melanges[i][0]=(x&0x00ff0000)>>16;
			melanges[i][1]=(x&0x0000ff00)>>8;
			melanges[i][2]=(x&0x000000ff);
			i++;
		}
		nbChaines=i;
		fclose(f);
	}
	else
		nbChaines=0;
	while(!testTouche(T_ESCAPE))		{
		clrscr();
		printf("Faites mumuse avec les couleurs pour voir ce que a donne...\n\nRouge: %03i    < ( ) >\nVert:  %03i    < ( ) >\nBleu:  %03i    < ( ) >\n\nCouleur: #%06x",r,v,b,RGB(b,v,r));
//			DessTexte(446,76,"Couleur resultante");
		if (degrade)		{
			ColoreCadre(10,111,580,100,RGB(r,v,b));
			for (i=0;i<256;i++)
				TransCadre(50+2*i,111,2,100,RGB(rd,vd,bd),(UCHAR)i);
			ColoreCadre(560,111,30,100,RGB(rd,vd,bd));
		}
		else	{
			ColoreCadre(10,111,580,100,RGB(r,v,b));
		}
		DessTexte(400,83,"Piquer une couleur...");
		if (nbChaines<=0)
			CouleurTexte(GRIS);
		DessTexte(400,95,"Couleurs personnelles...");
		DessTexte(300,83,"Dgrad...");
		CouleurTexte(TEXTE_NORMAL);
		diff=3*255;
		y=0;
		for (i=0;i<nbChaines;i++)		{
			j=abs(melanges[i][0]-r)+abs(melanges[i][1]-v)+abs(melanges[i][2]-b);
			if (j<diff)	{
				diff=j;
				y=i;
			}
		}
		if (diff!=3*255)			//Rsultat trouv?
			DessTexte(8,95,noms[y]);

		if (diff<=0)
			CouleurTexte(GRIS);
		DessTexte(300,95,"Ajouter...");
		CouleurTexte(TEXTE_NORMAL);

		for (x=0;x<256;x++)
			ColoreCadre(250+x,2*HAUT_CAR,1,HAUT_CAR,RGB(x,0,0));
		for (x=0;x<256;x++)
			ColoreCadre(250+x,3*HAUT_CAR,1,HAUT_CAR,RGB(0,x,0));
		for (x=0;x<256;x++)
			ColoreCadre(250+x,4*HAUT_CAR,1,HAUT_CAR,RGB(0,0,x));

		ColoreCadre(250+r-1,2*HAUT_CAR,3,HAUT_CAR,BLANC);
		ColoreCadre(250+v-1,3*HAUT_CAR,3,HAUT_CAR,BLANC);
		ColoreCadre(250+b-1,4*HAUT_CAR,3,HAUT_CAR,BLANC);

		PositionSouris(&x,&y);
		if (y>=96 && y<=98+HAUT_CAR && x>=400 && x<=590 && nbChaines>0)
			AdditionneCadre(400,96+1,190,HAUT_CAR,RGB(0,128,0));
		else if (y/HAUT_CAR==6 && x/LARG_CAR>=10 && x/LARG_CAR<=15)
			AdditionneCadre(10*LARG_CAR,6*HAUT_CAR,6*LARG_CAR,HAUT_CAR,RGB(128,64,0));
		else if (y>=84 && y<=84+HAUT_CAR && x>=400 && x<=568)
			AdditionneCadre(400,84+1,168,HAUT_CAR,RGB(128,0,128));
		else if (y>=96 && y<=98+HAUT_CAR && x>=300 && x<=380 && diff>0)
			AdditionneCadre(300,96+1,80,HAUT_CAR,RGB(128,0,0));
		else if (y>=84 && y<=86+HAUT_CAR && x>=300 && x<=380 && nbChaines>0)
			AdditionneCadre(300,84+1,80,HAUT_CAR,RGB(0,128,128));
		else if (y/HAUT_CAR>=2 && y/HAUT_CAR<=4 && (x/LARG_CAR)%2==0 && x/LARG_CAR>=14 && x/LARG_CAR<=20)		{
			AdditionneCadre((x/LARG_CAR)*LARG_CAR,(y/HAUT_CAR)*HAUT_CAR,LARG_CAR,HAUT_CAR,RGB(255,0,0));
		}
		else if (y/HAUT_CAR>=2 && y/HAUT_CAR<=4 && x/LARG_CAR>=7 && x/LARG_CAR<=9)		{
			AdditionneCadre(7*LARG_CAR,(y/HAUT_CAR)*HAUT_CAR,3*LARG_CAR,HAUT_CAR,RGB(255,0,0));
		}

		if (toucheAppuyee(T_SOURIS_DROIT) && nbChaines>0)		{
			TitreFenetre("Choisissez une couleur. Clic droit pour annuler");
			ChoisitCouleur(&r,&v,&b);
			TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
		}

		if (toucheAppuyee(T_SOURIS_MILIEU))		{
			CapturePoint(&r,&v,&b);
			TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
		}

		if (testTouche(T_SOURIS_GAUCHE))		{
			if (y>=96 && y<=98+HAUT_CAR && x>=400 && x<=590 && nbChaines>0)		{
				TitreFenetre("Choisissez une couleur. Clic droit pour annuler");
				ChoisitCouleur(&r,&v,&b);
				TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
			}
			else if (y/HAUT_CAR==6 && x/LARG_CAR>=10 && x/LARG_CAR<=15)		{
				ModeConsole();
				MoveTo(10,6);
				printf("      ");
				MoveTo(10,6);
				LongueurMax(7);
				gets(str);
				if (str[0])		{
					x=atox(str);
					r=(x&0x00ff0000)>>16;
					v=(x&0x0000ff00)>>8;
					b=(x&0x000000ff);
				}
				ModeGraphique();
			}
			else if (y>=84 && y<=84+HAUT_CAR && x>=400 && x<=568)		{
				CapturePoint(&r,&v,&b);
				TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
			}
			else if (y>=96 && y<=98+HAUT_CAR && x>=300 && x<=380 && diff>0)		{
				ModeConsole();
				texteX=8;
				texteY=97;
				printf("                         ");
				texteX=8;
				LongueurMax(21);
				VideTamponTouche();
				gets(str);
				if (str[0])		{
					for (i=0;i<nbChaines;i++)
						if (strcmp(str,noms[i])==0)
							break;
					if (i>=nbChaines)		{
						f=fopen("couleurs.txt","a");
						sprintf(str2,"%s=#%06x\n",str,RGB(b,v,r));
						fputs(str2,f);
						fclose(f);
					}
				}
				ModeGraphique();
				goto debut;
			}
			else if (y>=84 && y<=86+HAUT_CAR && x>=300 && x<=380 && nbChaines>0)		{
				TitreFenetre("Dgrad vers quelle couleur? Clic droit=aucune");
				degrade=ChoisitCouleur(&rd,&vd,&bd);
				TitreFenetre("Testeur de couleurs RVB - powered by WinGraph");
			}
			if (y/HAUT_CAR==2)
				r=ModValeur(r);
			else if (y/HAUT_CAR==3)
				v=ModValeur(v);
			else if (y/HAUT_CAR==4)
				b=ModValeur(b);
		}
		else
			interdit=0;
		AfficheEcran();
		AttendSync(10);
	}
}
